Index: /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 9425)
+++ /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.dbml	(revision 9426)
@@ -114,5 +114,5 @@
     <Type Name="TaskData">
       <Column Name="TaskId" Storage="_JobId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" CanBeNull="false" />
-      <Column Name="Data" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX)" CanBeNull="false" UpdateCheck="Never" />
+      <Column Name="Data" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX)" CanBeNull="false" UpdateCheck="Never" IsDelayLoaded="true" />
       <Column Name="LastUpdate" Type="System.DateTime" DbType="DateTime" CanBeNull="false" />
       <Association Name="Task_TaskData" Member="Task" Storage="_Job" ThisKey="TaskId" OtherKey="TaskId" Type="Task" IsForeignKey="true" />
@@ -123,5 +123,5 @@
       <Column Name="PluginDataId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
       <Column Name="PluginId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" CanBeNull="false" />
-      <Column Name="Data" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX) NOT NULL" CanBeNull="false" UpdateCheck="Never" />
+      <Column Name="Data" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX) NOT NULL" CanBeNull="false" UpdateCheck="Never" IsDelayLoaded="true" />
       <Column Name="FileName" Type="System.String" DbType="VarChar(MAX)" CanBeNull="false" />
       <Association Name="Plugin_PluginData" Member="Plugin" ThisKey="PluginId" OtherKey="PluginId" Type="Plugin" IsForeignKey="true" />
Index: /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 9425)
+++ /trunk/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.designer.cs	(revision 9426)
@@ -3,5 +3,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.17929
+//     Runtime Version:4.0.30319.18034
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -2661,5 +2661,5 @@
 		private System.Guid _JobId;
 		
-		private System.Data.Linq.Binary _Data;
+		private System.Data.Linq.Link<System.Data.Linq.Binary> _Data;
 		
 		private System.DateTime _LastUpdate;
@@ -2714,13 +2714,13 @@
 			get
 			{
-				return this._Data;
-			}
-			set
-			{
-				if ((this._Data != value))
+				return this._Data.Value;
+			}
+			set
+			{
+				if ((this._Data.Value != value))
 				{
 					this.OnDataChanging(value);
 					this.SendPropertyChanging();
-					this._Data = value;
+					this._Data.Value = value;
 					this.SendPropertyChanged("Data");
 					this.OnDataChanged();
@@ -2814,5 +2814,5 @@
 		private System.Guid _PluginId;
 		
-		private System.Data.Linq.Binary _Data;
+		private System.Data.Linq.Link<System.Data.Linq.Binary> _Data;
 		
 		private string _FileName;
@@ -2889,13 +2889,13 @@
 			get
 			{
-				return this._Data;
-			}
-			set
-			{
-				if ((this._Data != value))
+				return this._Data.Value;
+			}
+			set
+			{
+				if ((this._Data.Value != value))
 				{
 					this.OnDataChanging(value);
 					this.SendPropertyChanging();
-					this._Data = value;
+					this._Data.Value = value;
 					this.SendPropertyChanged("Data");
 					this.OnDataChanged();
Index: /trunk/sources/HeuristicLab.Services.Hive/3.3/Convert.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 9425)
+++ /trunk/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 9426)
@@ -67,5 +67,4 @@
         target.LastHeartbeat = source.LastHeartbeat;
         target.State = Convert.ToEntity(source.State);
-        if (target.StateLogs == null) target.StateLogs = new EntitySet<DB.StateLog>();
         foreach (DT.StateLog sl in source.StateLog.Where(x => x.Id == Guid.Empty)) {
           target.StateLogs.Add(Convert.ToEntity(sl));